(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/cdk/overlay'), require('@angular/cdk/portal'), require('rxjs'), require('rxjs/operators'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('@benevideschissanga/ngx-bootstrap-alert-notification', ['exports', '@angular/core', '@angular/cdk/overlay', '@angular/cdk/portal', 'rxjs', 'rxjs/operators', '@angular/common'], factory) :
    (global = global || self, factory((global.benevideschissanga = global.benevideschissanga || {}, global.benevideschissanga['ngx-bootstrap-alert-notification'] = {}), global.ng.core, global.ng.cdk.overlay, global.ng.cdk.portal, global.rxjs, global.rxjs.operators, global.ng.common));
}(this, (function (exports, core, overlay, portal, rxjs, operators, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    var NotificationData = /** @class */ (function () {
        function NotificationData() {
        }
        return NotificationData;
    }());
    var NotificationAlertContainerStyles = /** @class */ (function () {
        function NotificationAlertContainerStyles() {
        }
        return NotificationAlertContainerStyles;
    }());
    var DefaultNotificationConfig = /** @class */ (function () {
        function DefaultNotificationConfig() {
            this.animation = true;
            this.dismissible = true;
            this.position = 'topLeft';
            this.timeOut = 5;
            this.unique = false;
        }
        DefaultNotificationConfig = __decorate([
            core.Injectable()
        ], DefaultNotificationConfig);
        return DefaultNotificationConfig;
    }());
    var defaultNotificationCofigValues = {
        position: 'topRight',
        animation: true,
        timeOut: 5,
        dismissible: true,
    };
    var NOTIFICATION_CONFIG_TOKEN = new core.InjectionToken('notification-config');

    var NgxNotificationRef = /** @class */ (function () {
        function NgxNotificationRef(overlay, nt) {
            this.overlay = overlay;
            this.nt = nt;
        }
        NgxNotificationRef.prototype.close = function () {
            this.overlay.dispose();
            this.clearMessage();
        };
        NgxNotificationRef.prototype.isVisible = function () {
            return this.overlay && this.overlay.overlayElement;
        };
        NgxNotificationRef.prototype.getPosition = function () {
            return this.overlay.overlayElement.getBoundingClientRect();
        };
        NgxNotificationRef.prototype.clearMessage = function () {
            this.nt.lastMessage = null;
        };
        return NgxNotificationRef;
    }());

    var NgxBootstrapAlertNotificationComponent = /** @class */ (function () {
        function NgxBootstrapAlertNotificationComponent(data, ref, containerStyles, notificationConfig) {
            this.data = data;
            this.ref = ref;
            this.containerStyles = containerStyles;
            this.notificationConfig = notificationConfig;
            this.animatedClass = 'fadeInDown';
        }
        NgxBootstrapAlertNotificationComponent.prototype.ngOnInit = function () {
            if (this.notificationConfig.dismissible) {
                this.dismissibleTimer();
            }
            this.show = true;
        };
        NgxBootstrapAlertNotificationComponent.prototype.close = function () {
            var _this = this;
            if (this.notificationConfig.animation) {
                this.animatedClass = 'fadeOutUp';
                this.show = false;
                rxjs.timer(1000)
                    .pipe(operators.take(1))
                    .subscribe(function (t) { return _this.ref.close(); });
            }
            else {
                this.show = false;
                this.ref.close();
            }
        };
        NgxBootstrapAlertNotificationComponent.prototype.onMouseOver = function () {
            if (this.notificationConfig.dismissible) {
                this.notification.paused.next(true);
            }
        };
        NgxBootstrapAlertNotificationComponent.prototype.onMouseLeave = function () {
            if (this.notificationConfig.dismissible) {
                this.notification.paused.next(false);
            }
        };
        NgxBootstrapAlertNotificationComponent.prototype.dismissibleTimer = function () {
            var _this = this;
            var subject = new rxjs.BehaviorSubject(false);
            this.notification = {
                paused: subject,
                obs: this.getPausableTimer(this.notificationConfig.timeOut, subject),
            };
            this.notification.obs.completeTimer
                .pipe(operators.take(1))
                .subscribe(function (t) { return _this.close(); });
        };
        NgxBootstrapAlertNotificationComponent.prototype.getPausableTimer = function (timeout, pause) {
            var pausableTimer$ = rxjs.defer(function () {
                var seconds = 1;
                return rxjs.interval(1000).pipe(operators.withLatestFrom(pause), operators.filter(function (_a) {
                    var _b = __read(_a, 2), v = _b[0], paused = _b[1];
                    return !paused;
                }), operators.take(timeout), operators.map(function () { return seconds++; }));
            }).pipe(operators.share());
            return {
                stepTimer: pausableTimer$,
                completeTimer: pausableTimer$.pipe(operators.reduce(function (x, y) { return y; })),
            };
        };
        NgxBootstrapAlertNotificationComponent.ctorParameters = function () { return [
            { type: NotificationData },
            { type: NgxNotificationRef },
            { type: NotificationAlertContainerStyles },
            { type: undefined, decorators: [{ type: core.Inject, args: [DefaultNotificationConfig,] }] }
        ]; };
        __decorate([
            core.HostListener('mouseover')
        ], NgxBootstrapAlertNotificationComponent.prototype, "onMouseOver", null);
        __decorate([
            core.HostListener('mouseleave')
        ], NgxBootstrapAlertNotificationComponent.prototype, "onMouseLeave", null);
        NgxBootstrapAlertNotificationComponent = __decorate([
            core.Component({
                selector: 'ngx-bootstrap-alert-notification',
                template: "\n    <div\n      [ngStyle]=\"containerStyles\"\n      class=\"col-11 col-sm-4 notification-container\"\n    >\n      <div\n        *ngIf=\"!data.template\"\n        [class.alert-dismissible]=\"notificationConfig.dismissible\"\n        [class.alert-with-icon]=\"data.icon\"\n        [class.animated]=\"notificationConfig.animation\"\n        [class.show]=\"show\"\n        [ngClass]=\"['alert-' + data.type, animatedClass]\"\n        class=\"alert fade\"\n        role=\"alert\"\n      >\n        <button\n          (click)=\"close()\"\n          aria-label=\"Close\"\n          class=\"close\"\n          type=\"button\"\n        >\n          <span aria-hidden=\"true\">\u00D7</span>\n        </button>\n        <h4 *ngIf=\"data.title as title\" class=\"title\">{{ title }}</h4>\n        <span\n          *ngIf=\"data.icon as icon\"\n          [className]=\"icon\"\n          data-notify=\"icon\"\n        ></span>\n        <span data-notify=\"message\">\n          {{ data.message }}\n        </span>\n      </div>\n      <ng-container\n        *ngIf=\"data.template as templateRef\"\n        [ngTemplateOutlet]=\"templateRef\"\n      ></ng-container>\n    </div>\n  ",
                styles: ["\n      :host {\n        z-index: 1051;\n        position: fixed;\n        display: block;\n      }\n\n      .title {\n        margin-bottom: 0;\n        color: white;\n      }\n\n      @keyframes fadeInDown {\n        from {\n          opacity: 0;\n          transform: translate3d(0, -100%, 0);\n        }\n\n        to {\n          opacity: 1;\n          transform: translate3d(0, 0, 0);\n        }\n      }\n\n      .fadeInDown {\n        animation-name: fadeInDown;\n      }\n\n      @keyframes fadeOutUp {\n        from {\n          opacity: 1;\n        }\n\n        to {\n          opacity: 0;\n          transform: translate3d(0, -100%, 0);\n        }\n      }\n\n      .fadeOutUp {\n        animation-name: fadeOutUp;\n      }\n\n      .animated {\n        animation-duration: 1s;\n        animation-fill-mode: both;\n      }\n    "]
            }),
            __param(3, core.Inject(DefaultNotificationConfig))
        ], NgxBootstrapAlertNotificationComponent);
        return NgxBootstrapAlertNotificationComponent;
    }());

    var Styles = {
        display: 'inline-block',
        margin: '0px auto',
        position: 'fixed',
        transition: 'all 0.5s ease-in-out',
        zIndex: '1031',
    };
    var NgxBootstrapAlertNotificationService = /** @class */ (function () {
        function NgxBootstrapAlertNotificationService(overlay, parentInjector, notificationConfig) {
            this.overlay = overlay;
            this.parentInjector = parentInjector;
            this.notificationConfig = notificationConfig;
        }
        NgxBootstrapAlertNotificationService_1 = NgxBootstrapAlertNotificationService;
        Object.defineProperty(NgxBootstrapAlertNotificationService.prototype, "lastMessage", {
            set: function (value) {
                this._lastMessage = value;
            },
            enumerable: true,
            configurable: true
        });
        NgxBootstrapAlertNotificationService.prototype.show = function (data, config) {
            if (!config ||
                (config && !config.unique) ||
                (config &&
                    config.unique &&
                    ((Array.isArray(this._lastMessage) &&
                        (this._lastMessage || []).includes(data.message)) ||
                        this._lastMessage !== data.message))) {
                this._lastMessage = data.message;
                var positionStrategy = this.getPositionStrategy();
                var overlayRef = this.overlay.create({ positionStrategy: positionStrategy });
                var notificationRef = new NgxNotificationRef(overlayRef, this.parentInjector.get(NgxBootstrapAlertNotificationService_1));
                var injector = this.getInjector(data, notificationRef, this.parentInjector, config, this.createContainerStyles(config));
                this.lastNotification = notificationRef;
                var toastPortal = new portal.ComponentPortal(NgxBootstrapAlertNotificationComponent, null, injector);
                overlayRef.attach(toastPortal);
                return notificationRef;
            }
            return null;
        };
        NgxBootstrapAlertNotificationService.prototype.getPositionStrategy = function () {
            return this.overlay.position().global();
        };
        NgxBootstrapAlertNotificationService.prototype.getInjector = function (data, notificationRef, parentInjector, notificationConfig, containerStyles) {
            var tokens = new WeakMap();
            tokens.set(NotificationData, data);
            tokens.set(NgxNotificationRef, notificationRef);
            if (notificationConfig) {
                notificationConfig = __assign(__assign({}, this.notificationConfig), notificationConfig);
                tokens.set(DefaultNotificationConfig, notificationConfig);
            }
            if (containerStyles) {
                tokens.set(NotificationAlertContainerStyles, containerStyles);
            }
            return new portal.PortalInjector(parentInjector, tokens);
        };
        NgxBootstrapAlertNotificationService.prototype.createContainerStyles = function (config) {
            var styles = __assign({}, Styles);
            var notificationContainer;
            if (this.lastNotification) {
                var element = this.lastNotification.isVisible();
                notificationContainer = element
                    ? element.querySelector('.notification-container')
                    : null;
            }
            var conf = __assign(__assign({}, this.notificationConfig), (config || {}));
            if (conf.position && conf.position.includes('top')) {
                styles.top =
                    notificationContainer && notificationContainer.style.top
                        ? parseFloat(notificationContainer.style.top) +
                            notificationContainer.clientHeight + "px"
                        : '20px';
                switch (conf.position) {
                    case 'topLeft':
                        styles.left = '20px';
                        break;
                    case 'topCenter':
                        styles.left = '0px';
                        styles.right = '0px';
                        break;
                    case 'topRight':
                        styles.right = '20px';
                        break;
                    default:
                        break;
                }
            }
            else {
                styles.bottom =
                    notificationContainer && notificationContainer.style.bottom
                        ? parseFloat(notificationContainer.style.bottom) +
                            notificationContainer.clientHeight + "px"
                        : '20px';
                switch (conf.position) {
                    case 'bottomLeft':
                        styles.left = '20px';
                        break;
                    case 'bottomCenter':
                        styles.left = '0px';
                        styles.right = '0px';
                        break;
                    case 'bottomRight':
                        styles.right = '20px';
                        break;
                    default:
                        break;
                }
            }
            return styles;
        };
        var NgxBootstrapAlertNotificationService_1;
        NgxBootstrapAlertNotificationService.ctorParameters = function () { return [
            { type: overlay.Overlay },
            { type: core.Injector },
            { type: undefined, decorators: [{ type: core.Inject, args: [DefaultNotificationConfig,] }] }
        ]; };
        NgxBootstrapAlertNotificationService.ɵprov = core["ɵɵdefineInjectable"]({ factory: function NgxBootstrapAlertNotificationService_Factory() { return new NgxBootstrapAlertNotificationService(core["ɵɵinject"](overlay.Overlay), core["ɵɵinject"](core.INJECTOR), core["ɵɵinject"](DefaultNotificationConfig)); }, token: NgxBootstrapAlertNotificationService, providedIn: "root" });
        NgxBootstrapAlertNotificationService = NgxBootstrapAlertNotificationService_1 = __decorate([
            core.Injectable({
                providedIn: 'root',
            }),
            __param(2, core.Inject(DefaultNotificationConfig))
        ], NgxBootstrapAlertNotificationService);
        return NgxBootstrapAlertNotificationService;
    }());

    var NgxBootstrapAlertNotificationModule = /** @class */ (function () {
        function NgxBootstrapAlertNotificationModule() {
        }
        NgxBootstrapAlertNotificationModule_1 = NgxBootstrapAlertNotificationModule;
        NgxBootstrapAlertNotificationModule.forRoot = function (config) {
            return {
                ngModule: NgxBootstrapAlertNotificationModule_1,
                providers: [
                    {
                        provide: DefaultNotificationConfig,
                        useValue: config ? config : defaultNotificationCofigValues,
                    },
                ],
            };
        };
        var NgxBootstrapAlertNotificationModule_1;
        NgxBootstrapAlertNotificationModule = NgxBootstrapAlertNotificationModule_1 = __decorate([
            core.NgModule({
                declarations: [NgxBootstrapAlertNotificationComponent],
                imports: [common.CommonModule, overlay.OverlayModule],
                entryComponents: [NgxBootstrapAlertNotificationComponent],
                exports: [NgxBootstrapAlertNotificationComponent],
            })
        ], NgxBootstrapAlertNotificationModule);
        return NgxBootstrapAlertNotificationModule;
    }());

    exports.DefaultNotificationConfig = DefaultNotificationConfig;
    exports.NOTIFICATION_CONFIG_TOKEN = NOTIFICATION_CONFIG_TOKEN;
    exports.NgxBootstrapAlertNotificationComponent = NgxBootstrapAlertNotificationComponent;
    exports.NgxBootstrapAlertNotificationModule = NgxBootstrapAlertNotificationModule;
    exports.NgxBootstrapAlertNotificationService = NgxBootstrapAlertNotificationService;
    exports.NotificationAlertContainerStyles = NotificationAlertContainerStyles;
    exports.NotificationData = NotificationData;
    exports.defaultNotificationCofigValues = defaultNotificationCofigValues;
    exports.ɵa = NgxNotificationRef;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=benevideschissanga-ngx-bootstrap-alert-notification.umd.js.map
